#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

void fill(vector<ll>& h) {
    for (int i = 1; i < h.size(); i++) cin >> h[i];
}

int main()
{
    int n; cin >> n;
    vector<ll> h(n + 1, 0); fill(h);
    vector<bool> link(n, 0);

    for (int i = 0; i < n - 1; i++) {
        int k; cin >> k;
        int k1 = k;
        while (link[k1]) k1++;
        link[k1] = true;
        ll w = 0;
        vector<ll> st; st.push_back(h[k]);
        for (int i = 1; i < n; i++) cout << link[i] << ' ';
        cout << endl;
        while (k < n && link[k]) {
            ll s = k + 1;
            if (st.empty()) st.push_back(h[s]);
            else if (st.back() >= h[s]) {
                st.push_back(h[s]);
            }
            else {
                ll k = st.size();
                ll m = 0;
                while ((!st.empty()) && st.back() < h[s]) {
                    w += h[s] - st.back();
                    m = max(m, st.back());
                    st.pop_back();
                }
                if (st.empty()) w -= (h[s] - m) * k;
            }
            k++;
        }
        cout << w << '\n';
    }

    return 0;
}
