#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

void fill(vector<ll>& v) {
    for (int i = 0; i < v.size(); i++) cin >> v[i];
}

ll INF = 1e18;

int main()
{
    int k, n; cin >> n >> k;
    vector<ll> a(n, 0); fill(a);

    vector<ll> p(n + 1, 0);
    for (int i = 1; i < n + 1; i++) {
        p[i] = p[i - 1] + a[i - 1];
    }

    vector<ll> p_m(n + 1, INF);
    vector<ll> s_m(n + 1, INF);
    for (int i = 1; i < n + 1; i++) {
        p_m[i] = min(p_m[i - 1], a[i - 1]);
    }

    s_m[n] = a[n - 1];
    for (int i = n - 1; i > 0; i--) {
        s_m[i] = min(a[i - 1], s_m[i + 1]);
    }

    ll ans = -INF;

    ll st = n - k + 1;

    if (k == 2) {
        ans = max(abs(p[n - 1] - s_m[n]), abs(p[n] - p[1] - p_m[1]));
        cout << ans; return 0;
    }
    if (k == 3) {
        bool f = false;



        for (int i = 1; i <= n && (!f); i++) {
            for (int j = i; j <= n && (j - i <= n - k + 1); j++) {
                if (i == 1) {
                    ans = max(p[j] - p[i - 1] - a[j], ans);
                }
                else if (j == n) {
                    ans = max(ans, p[j] - p[i - 1] - a[i - 2]);
                    f = true;
                }
                else {
                    ans = max(ans, p[j] - p[i - 1] - min(p[i - 1], p[n] - p[j]));
                }
            }
        }
    }

    cout << ans << endl;

    return 0;
}
