#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef string str;

vector<char> dig = { '2', '3', '5', '7' };

ll cnt_dl(str n) {
    ll ans = 0;
    str s(n.size(), '1');
    for (int i = 0; i < s.size(); i++) {
        for (int j = 0; j < dig.size(); j++) {
            str s1 = s; s1[i] = dig[j];
            if (s1 >= n) {
                ans += dig.size() - j;
                break;
            }
        }

    }
    return ans;
}

ll cnt_dr(str n) {
    ll ans = 0;
    str s(n.size(), '1');
    for (int i = 0; i < s.size(); i++) {
        for (int j = 0; j < dig.size(); j++) {
            str s1 = s; s1[i] = dig[j];
            if (s1 > n) break;
            ans += 1;
        }
    }
    return ans;
}

int main()
{
    str l, r; cin >> l >> r;
    vector<ll> dp(r.size() + 1, 0);
    ll ans = (8 + 4 * (r.size() - 2)) * (r.size() - 1) / 2 - (8 + 4 * (l.size() - 1)) * l.size() / 2;

    if (l.size() == r.size()) {
        if (l.back() != '0') l[l.size() - 1]--;
        ans = cnt_dr(r) - cnt_dr(l);
    }
    else {
        ans += cnt_dl(l);
        ans += cnt_dr(r);
    }

    cout << ans << endl;

    return 0;
}
