#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

void fill(vector<ll>& v) {
    for (int i = 0; i < v.size(); i++) cin >> v[i];
}

ll INF = 1e18;

int main()
{
    int k, n; cin >> n >> k;
    vector<ll> a(n, 0); fill(a);

    vector<ll> p(n + 1, 0);
    for (int i = 1; i < n + 1; i++) {
        p[i] = p[i - 1] + a[i - 1];
    }

    vector<ll> p_m(n + 1, INF);
    vector<ll> s_m(n + 1, INF);
    for (int i = 1; i < n + 1; i++) {
        p_m[i] = min(p_m[i - 1], a[i - 1]);
    }

    s_m[n] = a[n - 1];
    for (int i = n - 1; i > 0; i--) {
        s_m[i] = min(a[i - 1], s_m[i + 1]);
    }

    ll ans = -INF;

    int st = n - k + 1;

    for (int i = n - k + 1; i <= n; i++) {
        ll s = p[i] - p[i - st];
        if (i == st) {
            ans = max(ans, abs(s - s_m[i + 1]));
        }
        else if (i == n) {
            ans = max(ans, abs(s - p_m[i - st]));
        }
        else {
            ans = max(ans, max(abs(s - s_m[i + 1]), abs(s - p_m[i - st])));
        }
    }

    cout << ans << endl;

    return 0;
}
